% $B%i%W%i%9J}Dx<0$NFbItNN0hLdBj(B
% {(x,y);x^2+y^2<rho^2}
% $B&$(Bu = 0 
% u(x,y)=rho^m * cos(m theta) (cos=real)
% dipole $B%7%_%e%l!<%7%g%s!#AP6K;RDL>o%9%-!<%`!#(B
% $B7KEDO@J8(B Fig 9-3 $B$N%0%i%U!#(B

format "long" "e"

rho=1;
R=2;

mmax=5;  % m $B$N:GBgCM(B
Nmax=64; % N ( $BJ,3d?t(B )$B$N:GBgCM(B

maxerror=zeros(Nmax-1,mmax); 
ns=2:Nmax;

for N=2:Nmax;    
  
  omega=exp(2*pi*I/N);      % $B&X(B $B$NCM(B
  w=exp(2*pi*I*(0:N-1)/N)'; % $B%Y%/%H%k(B ($B&X(B^1 $B&X(B^2 $B!D(B $B&X(B^N-1)' 
  
  x=rho*w; % $B94B+E@(B
  y=R*w;   % $BEE2YE@(B
  nu=(1/R)*y; % $B&M(B_y $BC10L%Y%/%H%k(B

  Fs=zeros(N,mmax); % F; f $B$r(B mmax $BNsJB$Y$F9TNs$r:n$k(B
  for m=1:mmax 
    f=real(x.^m);    
    Fs(:,m)=f;
  end 
  
  G=zeros(N,N);
  for i=1:N
   G(:,i)=(-1/(2*pi))*(real(nu(i).*(((y(i)-x)').'))./(abs((y(i)-x))).^2); 
   % Dipole G
  end
  
  Qs=G\Fs; % Q; N $B9T(B mmax $BNs$N9TNs(B
  
  n=100; % $B6-3&>e$K(B n $B8D$NE@$r<h$k(B
  theta=2*pi*rand(n,1);
  Z=rho*exp(I*theta);
  error=zeros(n,mmax); 
  for m=1:mmax
    Q=Qs(:,m);
    for l=1:n
      U=Q'*((-1/(2*pi))*real(nu.*(((y-Z(l))').'))./(abs(y-Z(l))).^2); 
      % Dipole $B$K$h$k6a;w2r(B
     
      xx=Z(l).^m;
   
      u=real(xx); % $B6-3&>e$NE@$NCM(B
      
      error(l,m)=abs(u-U); % $B6-3&>e$G87L)2r$H6a;w2r$rHf3S(B
    end
    
    maxerror(N-1,m)=max(error(:,m)); % error $B$N:GBgCM$r<h$j5-21(B
  end
end
% $B%0%i%UI=<((B
gset title"Conventional Dipole Scheme"
gset xlabel"N"
gset ylabel"log_10(e^(N))"

semilogy(ns,maxerror)
gset term postscript eps color
gset output "fig9-3.eps"
replot
