% $B%i%W%i%9J}Dx<0$NFbItNN0hLdBj(B
% {(x,y);x^2+y^2<rho^2}
% $B&$(Bu = 0 
% u(x,y)=rho^m * cos(m theta) (cos=real)
% dipole $B%7%_%e%l!<%7%g%s!#AP6K;RITJQ%9%-!<%`!#(B

format "long" "e"

rho=1;
R=2;

mmax=5;  % m $B$N:GBgCM(B
Nmax=64; % N ( $BJ,3d?t(B )$B$N:GBgCM(B

maxerror=zeros(Nmax-1,mmax); %
ns=2:Nmax;
fo=zeros(1,mmax);

for N=2:Nmax;    
  
  gp1=[0 ones(1,N)];
  gp2=ones(N,1);

  omega=exp(2*pi*I/N);
  w=exp(2*pi*I*(0:N-1)/N)';
  
  x=rho*w;
  y=R*w;
  nu=(1/R)*y;

  Fs=zeros(N,mmax); % F; f $B$r(B mmax $BNsJB$Y$F9TNs$r:n$k(B
  for m=1:mmax 
    f=real(x.^m);    
    Fs(:,m)=f;
    Fos=[fo ; Fs];
  end 
  
  G=zeros(N,N);
  for i=1:N
   G(:,i)=(-1/(2*pi))*(real(nu(i).*(((y(i)-x)').'))./(abs((y(i)-x))).^2); 
   % Dipole G
  end
  Gtilde=[gp1;[gp2 G]];

  Qos=Gtilde\Fos; % Q; N $B9T(B mmax $BNs$N9TNs(B
  
  n=100; % $B6-3&>e$K(B n $B8D$NE@$r<h$k(B
  theta=2*pi*rand(n,1);
  Z=rho*exp(I*theta);
  error=zeros(n,mmax);

  Qo2=zeros(N-1,1); 
  
  for m=1:mmax
    Qo=Qos(:,m);
    
    for s=1:N
      Qo2(s)=Qo(s+1);
    end
   
    for l=1:n
      U=Qo(1)+(Qo2'*((-1/(2*pi))*real(nu.*(((y-Z(l))').'))./(abs(y-Z(l))).^2));
      % $B6a;w2r(B
     
      xx=Z(l).^m;
   
      u=real(xx); % $B6-3&>e$NE@$NCM(B
      
      error(l,m)=abs(u-U);
    end
    
    maxerror(N-1,m)=max(error(:,m)); % error $B$N:GBgCM$r<h$j5-21(B
  end
end
% $B%0%i%UI=<((B
gset title"Invariant Dipole Scheme"
gset xlabel"N"
gset ylabel"log_10(e^(N))"

semilogy(ns,maxerror)
gset term postscript eps color
gset output "invdipole.eps"
replot

