% $B%i%W%i%9J}Dx<0$N(B Neumann $BLdBj(B
% {(x,y);x^2+y^2<rho^2}
% $B&$(Bu = 0 
% d/d nu u(x,y)= s_m = rho^m-1 * cos(m theta) (cos=real)
% $BDL>o%9%-!<%`$K$h$j2r$/!#87L)2r$H6a;w2r$N8m:9I=<(!#(B

format "long" "e"

rho=1;
R=2;

mmax=5;  % m $B$N:GBgCM(B
Nmax=64; % N ( $BJ,3d?t(B )$B$N:GBgCM(B

maxerror=zeros(Nmax-1,mmax);
ns=2:Nmax;

for N=2:Nmax

  omega=exp(2*pi*I/N);       % $B&X(B $B$NCM(B
  theta=(2*pi*(0:N-1)/N)';
  w=exp(theta*I);            % $B%Y%/%H%k(B ($B&X(B^1 $B&X(B^2 $B!D(B $B&X(B^N-1)'

  x=rho*w;      % $B94B+E@(B
  y=R*w;        % $BEE2YE@(B 
  nu=(1/rho)*x; % $B&M(B_x

  Fs=zeros(N,mmax); % F; f $B$r(B mmax $BNsJB$Y$F9TNs$r:n$k(B
  for m=1:mmax 
    f=rho^(m-1)*cos(m*theta); 
    Fs(:,m)=f;
  end 

  G=zeros(N,N);
  for i=1:N
    G(:,i)=(-1/(2*pi))*( real((x-y(i)).*((nu').'))./(abs(x-y(i)).^2) );
    % G; d /d $B&M(B_x ( E(x_i,y_j)) $B$rMWAG$H$7$?(B N*N $B9TNs(B
  end

  Qs=G\Fs;

  n=100;
  Ztheta=(2*pi*rand(n,1));
  Z=rho*exp(Ztheta*I);
  error=zeros(n,mmax);
  for m=1:mmax
    Q=Qs(:,m);
    for l=1:n
      U=(Q'*(-log(abs(Z(l)-y))))/(2*pi); %$BDL>o%9%-!<%`$K$h$k6a;w2r!#(B
      U0=(Q'*(-log(abs(-y))))/(2*pi);    % x=0 $B$N;~$NCM!#8m:9$rHf$Y$k$?$a!#(B

      u=(rho/m)*rho^(m-1)*cos(m*Ztheta(l)); %$B87L)2r(B r=rho $B$N$H$-!#(B
      u0=(rho/m)*rho^(m-1)*0;

      error(l,m)=abs((U-U0)-(u-u0));
    end

    maxerror(N-1,m)=max(error(:,m));
  end
end

% $B%0%i%UI=<((B
gset title"Conventional Scheme"
gset xlabel"N"
gset ylabel"log_10(e^(N))"

semilogy(ns,maxerror)
gset term postscript eps color
gset output "neumann.eps"
replot


