% $B%i%W%i%9J}Dx<0$N30ItNN0hLdBj(B
% {(x,y);x^2+y^2>rho^2}
% $B&$(Bu = 0 
% u(x,y)=(1/rho)^m * cos(m theta) (cos=real)
% $BDL>o%9%-!<%`$K$h$j2r$/!#(B
% $B94B+E@$r(B kappa = 1/2 $B$:$i$9!#(B N $B$O4q?t$H$9$k!#(B

format "long" "e"

rho=2;
R=0.8;

mmax=5;  % m $B$N:GBgCM(B
Nmax=64; % N ( $BJ,3d?t(B )$B$N:GBgCM(B

maxerror=zeros(Nmax/2-1,mmax);
ns=3:2:Nmax;

for N=3:2:Nmax;    
  
  omega=exp(2*pi*I/N);      % $B&X(B $B$NCM(B
  theta=(2*pi*(0:N-1)/N)';
  w=exp(theta*I); % $B%Y%/%H%k(B ($B&X(B^1 $B&X(B^2 $B!D(B $B&X(B^N-1)'
  
  kappa=0.5;
  diffth=2*pi*kappa/N;
  diff=exp(diffth*I);   
  x=rho*w*diff; % $B94B+E@(B
  y=R*w;        % $BEE2YE@(B

  Fs=zeros(N,mmax); % F; f $B$r(B mmax $BNsJB$Y$F9TNs$r:n$k(B
  for m=1:mmax 
    f=(1/rho)^m * cos(m*(theta+diffth));
    Fs(:,m)=f;
  end 

  G=zeros(N,N);
  for i=1:N
    G(i,:)=-(log(abs(x(i)-y)./abs(x(i))))'/(2*pi);
  end
  
  %
  Qs=G\Fs; %Q; N $B9T(B mmax $BNs$N9TNs(B
  %$B>e$N(B [\] $B$r;H$C$F7W;;$5$;$F$7$^$&$H(B 
  %Octave $B$O8m:9$r=$@5$7$F$7$^$&$h$&$@!#(B
  %$B$7$?$,$C$F!"(B Q $B$N$1$$$5$s$K$O2<$N$h$&$K(B
  %qr $BJ,2r$r;H$C$F7W;;$7$?!#(B
  %
  %
  %Qs=zeros(N,mmax);
  %w=zeros(N,1);
  %[q r] = qr(G);
  %for m=1:mmax  
  %  v=q'*Fs(:,m);
  %   
  %  w(N)=v(N)/r(N,N); 
  %  for k=N-1:-1:1
  %    w(k)=(v(k)-r(k,k+1:N)*w(k+1:N))/r(k,k);
  %  end
  %  Qs(:,m)=w;
  %end
  %

  n=100; % $B6-3&>e$K(B n $B8D$NE@$r<h$k(B
  Ztheta=2*pi*rand(n,1);
  Z=rho*exp(I*Ztheta);
  error=zeros(n,mmax); 
  for m=1:mmax
    Q=Qs(:,m);
    for l=1:n
      U=Q'*((-(log(abs(Z(l)-y)./abs(Z(l)) )))/(2*pi));% csm $B$K$h$k6a;w2r(B
      
      u=(1/rho)^m*cos(m*Ztheta(l));  % $B6-3&>e$N87L)2r$NCM(B
      
      error(l,m)=abs(u-U); % $B6-3&>e$G87L)2r$H6a;w2r$rHf3S(B
    end
    
    maxerror((N-1)/2,m)=max(error(:,m)); % error $B$N:GBgCM$r<h$j5-21(B
  end
end

% $B%0%i%UI=<((B
gset title"Conventional Scheme"
gset xlabel"N"
gset ylabel"log_10(e^(N))"

semilogy(ns,maxerror)
gset term postscript eps color
gset output "gaibucsmkappa.eps"
replot
