%omega={x in R^2 ; |x| > rho}
% Laplace $BJ}Dx<0$N(B Neumann $BLdBj(B
% f=(1/rho)^(n+1)*cos(n*theta) $B$G?tCM<B83!#(B
% $BITJQ%9%-!<%`$rMQ$$$k!#(B

format "long" "e"

rho=2;
R=0.8;

mmax=5;  % m $B$N:GBgCM(B
Nmax=64; % N ( $BJ,3d?t(B )$B$N:GBgCM(B

maxerror=zeros(Nmax-3,mmax);
ns=4:Nmax;
fo=zeros(1,mmax);

for N=4:Nmax

  gp1=[0 ones(1,N)];
  gp2=ones(N,1); 

  omega=exp(2*pi*I/N);
  theta=(2*pi*(0:N-1)/N)';
  w=exp(theta*I);

  x=rho*w;
  y=R*w;
  nu=(1/rho)*x;

  Fs=zeros(N,mmax); % F; f $B$r(B mmax $BNsJB$Y$F9TNs$r:n$k(B
  for m=1:mmax 
    f=(1/rho)^(m+1)*cos(m*theta);
    Fs(:,m)=f;
    Fos=[fo ; Fs];
  end 

  G=zeros(N,N);
  for i=1:N
%    G(:,i)=(-1/(2*pi))*( (real(((x-y(i)).*((nu').')))./((abs(x-y(i)).^2))) 
%- (real(( x.*((nu').')))./((abs(x).^2))) ); 
%      G(:,i)=(-1/(2*pi))*( (real(((x-y(i)).*((nu').')))./((abs(x-y(i)).^2))) 
%+ (real(( x.*((nu').')))./((abs(x).^2))) );
    G(:,i)=(-1/(2*pi))* real( ( -(x-y(i))./(abs((x-y(i)))).^2
+ (x)./(abs((x))).^2 ).*((nu').') ); 
  end
  Gtilde=[gp1;[gp2 G]];

  Qos=Gtilde\Fos; % Q; N $B9T(B mmax $BNs$N9TNs(B

  n=100;
  Ztheta=(2*pi*rand(n,1));
  Z=rho*exp(Ztheta*I);
  error=zeros(n,mmax);

  Qo2=zeros(N-1,1); 

  for m=1:mmax
    Qo=Qos(:,m);
    
    for s=1:N
      Qo2(s)=Qo(s+1);
    end

    for l=1:n
      U=Qo(1)+(Qo2'*(-log(abs(Z(l)-y)./abs(Z(l)))))/(2*pi); 
      % $BITJQ%9%-!<%`$K$h$k6a;w2r(B
      U0=Qo(1)+(Qo2'*(-log(abs(-y))))/(2*pi);% x=0 $B$N;~$NCM!#8m:9$rHf$Y$k$?$a!#(B  
      u=(rho/m)*(1/rho)^(m+1)*cos(m*Ztheta(l)); %$B87L)2r(B r=rho $B$N$H$-!#(B
      u0=(rho/m)*(1/rho)^(m+1)*0;

      error(l,m)=abs((U-U0)-(u-u0));
    end

    maxerror(N-3,m)=max(error(:,m)); % error $B$N:GBgCM$r<h$j5-21(B
  end
end

% $B%0%i%UI=<((B
gset title"Invariant Scheme"
gset xlabel"N"
gset ylabel"log_10(e^(N))"

semilogy(ns,maxerror)
gset term postscript eps color
gset output "gaibuneumann2.eps"
replot








