%Joukowski$BJQ49(B g(z)=(z+z^(-1))/2 $B$rMQ$$$F!"(B
%$BBJ1_NN0h$K$*$$$FBeMQEE2YK!$rE,MQ!#(B
%
%$BDL>o%9%-!<%`$K$*$1$k9M;!!#&J$rJQ$($F!#(B

format "long" "e"

rho=2;
R=4;

mmax=5;  % m $B$N:GBgCM(B
Nmax=100; % N ( $BJ,3d?t(B )$B$N:GBgCM(B

maxerror=zeros(Nmax-1,mmax);
ns=2:Nmax;

for N=2:Nmax;    
  
  omega=exp(2*pi*I/N);
  w=exp(2*pi*I*(0:N-1)/N)';
  kappa=0.5;
  diff=exp(2*pi*I*kappa/N);

  gx=rho*w*diff;
  gy=R*w;
  
  x=(gx+gx.^(-1))/2;
  y=(gy+gy.^(-1))/2;

  Fs=zeros(N,mmax); % F; f $B$r(B mmax $BNsJB$Y$F9TNs$r:n$k(B
  for m=1:mmax 
    f=real(x.^m);    
    Fs(:,m)=f;
  end 

  G=zeros(N,N);
  for i=1:N
    G(i,:)=-log(abs(x(i)-y))'/(2*pi);
  end

  Qs=G\Fs; % Q; N $B9T(B mmax $BNs$N9TNs(B
    
  n=100; % $B6-3&>e$K(B n $B8D$NE@$r<h$k(B
  theta=2*pi*rand(n,1);
  gZ=rho*exp(I*theta);
  Z=(gZ+gZ.^(-1))/2;
  error=zeros(n,mmax); 
  for m=1:mmax
    Q=Qs(:,m);
    for l=1:n
      U=(Q'*(-log(abs(Z(l)-y))))/(2*pi); % $BDL>o%9%-!<%`$K$h$k6a;w2r(B
     
      xx=Z(l).^m;
   
      u=real(xx); % $B6-3&>e$NE@$NCM(B
      
      error(l,m)=abs(u-U);
    end
    
    maxerror(N-1,m)=max(error(:,m)); % error $B$N:GBgCM$r<h$j5-21(B
  end
end

% $B%0%i%UI=<((B
gset title"Elliptic Domain Conventional Scheme"
gset xlabel"N"
gset ylabel"log_10(e^(N))"

semilogy(ns,maxerror)
gset term postscript eps color
gset output "elliptic.eps"
replot





