%Joukowski$BJQ49(B g(z)=(z+z^(-1))/2 $B$rMQ$$$F!"(B
%$BBJ1_NN0h$K$*$$$FBeMQEE2YK!$rE,MQ!#(B
%
%$BDL>o%9%-!<%`$K$*$1$k9M;!!#(B
%
%kappa = 0,rho=1.1,m=5(f=x^5) $B$r:NMQ!#(B
%R $B$NCM$rJQ2=$5$;$FI=<(!#(BR=1.2:0.4:4.0

format "long" "e"

rho=4.0;
R=[0.8:0.5:3.8]';
Rmax=length(R);

m=5;  % m $B$N:GBgCM(B
Nmax=100; % N ( $BJ,3d?t(B )$B$N:GBgCM(B

maxerror=zeros(Nmax-1,Rmax);
ns=2:Nmax;

for k=1:Rmax
  for N=2:Nmax   
  
    omega=exp(2*pi*I/N);
    theta=(2*pi*(0:N-1)/N)';
    w=exp(theta*I);           % $B%Y%/%H%k(B ($B&X(B^1 $B&X(B^2 $B!D(B $B&X(B^N-1)' 
    kappa=0.5;
    difftheta=2*pi*kappa/N;
    diff=exp(difftheta*I);

    gx=rho*w*diff;
    gy=R(k)*w;
  
    x=(gx+gx.^(-1))/2; % $B94B+E@(B
    y=(gy+gy.^(-1))/2; % $BEE2YE@(B 

    f=(1/rho)^m*cos(m*(difftheta+theta));   
  
    G=zeros(N,N);
    for i=1:N
      G(i,:)=-(log(abs(x(i)-y)./abs(x(i))))'/(2*pi);
    end

    Q=G\f; % Q; N $B9T(B mmax $BNs$N9TNs(B
    
    n=100; % $B6-3&>e$K(B n $B8D$NE@$r<h$k(B
    Ztheta=2*pi*rand(n,1);
    gZ=rho*exp(I*Ztheta);
    Z=(gZ+gZ.^(-1))/2;
    error=zeros(n,1); 
  
    for l=1:n
      U=Q'*((-(log(abs(Z(l)-y)./abs(Z(l)) )))/(2*pi)); % csm $B$K$h$k6a;w2r(B
      
      u=(1/rho)^m*cos(m*Ztheta(l)); % $B6-3&>e$N87L)2r$NCM(B

      %xx=real(Z(l));
   
      %u=xx^m; % $B6-3&>e$NE@$NCM(B
      
      error(l)=abs(u-U);
    end
    
    maxerror(N-1,k)=max(error); % error $B$N:GBgCM$r<h$j5-21(B
  end
end

% $B%0%i%UI=<((B
gset title"Elliptic Domain Conventional Scheme"
gset xlabel"N"
gset ylabel"log_10(e^(N))"

semilogy(ns,maxerror)
gset term postscript eps color
gset output "gaibuelliptic3.eps"
replot






